net.sf.saxon.value

## Class MemoClosure<T extends Item>

- java.lang.Object
- - net.sf.saxon.value.Closure<T>
  - - net.sf.saxon.value.MemoClosure<T>

- All Implemented Interfaces:
    Sequence

      public class MemoClosure<T extends Item>
      extends Closure<T>

  A MemoClosure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

  The MemoClosure is designed for use when the value is only read several times. The value is saved on the first evaluation and remembered for later use.

  The MemoClosure maintains a reservoir containing those items in the value that have already been read. When a new iterator is requested to read the value, this iterator first examines and returns any items already placed in the reservoir by previous users of the MemoClosure. When the reservoir is exhausted, it then uses an underlying Input Iterator to read further values of the underlying expression. If the value is not read to completion (for example, if the first user did exists($expr), then the Input Iterator is left positioned where this user abandoned it. The next user will read any values left in the reservoir by the first user, and then pick up iterating the base expression where the first user left off. Eventually, all the values of the expression will find their way into the reservoir, and future users simply iterate over the reservoir contents. Alternatively, of course, the values may be left unread.

  Delayed evaluation is used only for expressions with a static type that allows more than one item, so the evaluateItem() method will not normally be used, but it is supported for completeness.

  The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

  In Saxon-EE, a for-each loop can be multithreaded. If a variable declared outside the loop is evaluated as a MemoClosure, then a reference to the variable within the loop can result in concurrent attempts to evaluate the variable incrementally. This is prevented by synchronizing the evaluation methods.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `MemoClosure.ProgressiveIterator` A ProgressiveIterator starts by reading any items already held in the reservoir; when the reservoir is exhausted, it reads further items from the inputIterator, copying them into the reservoir as they are read.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static int` | `EMPTY`
    `protected int` | `state`

    - ### Fields inherited from class net.sf.saxon.value.Closure

      `depth, expression, inputIterator, savedXPathContext`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemoClosure()` Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isFullyRead()` Determine whether the contents of the MemoClosure have been fully read
    `SequenceIterator<T>` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
    `GroundedValue` | `materialize()` Return a value containing all the items in the sequence returned by this SequenceIterator
    `void` | `process(XPathContext context)` Process the expression by writing the value to the current Receiver

    - ### Methods inherited from class net.sf.saxon.value.Closure

      `getCardinality, getExpression, getItemType, getSavedXPathContext, head, make, reduce, saveContext, setExpression, setSavedXPathContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### state

          protected int state

    - #### EMPTY

          protected static final int EMPTY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MemoClosure

          public MemoClosure()

      Constructor should not be called directly, instances should be made using the make() method.

  - ### Method Detail

    - #### iterate

          public SequenceIterator<T> iterate()
                                                   throws XPathException

      Evaluate the expression in a given context to return an iterator over a sequence
      Specified by:
        `iterate` in interface `Sequence`
      Overrides:
        `iterate` in class `Closure<T extends Item>`
      Returns:
        an iterator over all the items
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and constructing an iterator over the items causes a dynamic error.

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the expression by writing the value to the current Receiver
      Overrides:
        `process` in class `Closure<T extends Item>`
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException`

    - #### isFullyRead

          public boolean isFullyRead()

      Determine whether the contents of the MemoClosure have been fully read
      Returns:
        true if the contents have been fully read

    - #### materialize

          public GroundedValue materialize()
                                    throws XPathException

      Return a value containing all the items in the sequence returned by this SequenceIterator
      Returns:
        the corresponding value
      Throws:
        `XPathException` - if a failure occurs reading the input

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.